
##-----------------------------------------------------------------------------
## All %%global definitions should be placed here and keep them sorted
##
%if ( 0%{?fedora} ) || ( 0%{?rhel} && 0%{?rhel} > 6 )
%global _with_systemd true
%endif


##-----------------------------------------------------------------------------
## All package definitions should be placed here
##
Summary:          Gluster block storage utility
Name:             gluster-block
Version:          0.2.1
Release:          14.1%{?dist}
License:          GPLv2 or LGPLv3+
URL:              https://github.com/gluster/gluster-block
Source0:          gluster-block-0.2.1.tar.gz

Patch0001:        0001-Terminate-gracefully-when-svc_register-fails.patch
Patch0002:        0002-runner-check-for-WIFEXITED-before-WEXITSTATUS.patch
Patch0003:        0003-runner-check-for-all-non-zero-exit-status-values.patch
Patch0004:        0004-logger-fix-null-prints-while-trying-to-log-volname.patch
Patch0005:        0005-block-add-support-to-prealloc-full-no-option.patch
Patch0006:        0006-cli-fix-missing-newline-characters.patch
Patch0007:        0007-Don-t-let-LOG-segfault-if-log-dir-does-not-exist-fal.patch
Patch0008:        0008-gluster-block-update-systemd-unit-and-spec-file.patch
Patch0009:        0009-Show-error-message-when-response-contains-failure.patch
Patch0010:        0010-tcmu-backstore-attribute-set-cmd_time_out-0.patch
Patch0011:        0011-create-move-saveconfig-out-of-the-loop.patch
Patch0012:        0012-gluster-block-do-not-allow-delete-if-any-node-is-dow.patch
Patch0013:        0013-gluster-block-support-force-delete-option.patch
Patch0014:        0014-logger-support-logdir-choosing-via-Environment-varia.patch
Patch0015:        0015-systemd-fix-systemd-dependency-list.patch
Patch0016:        0016-downstream-makefile-changes.patch
Patch0017:        0017-rpc-use-port-24010-for-all-gluster-blockd-management.patch
Patch0018:        0018-gluster-block-use-targetcli-interactive-mode.patch
Patch0019:        0019-gluster-block-parse-remote-command-outputs.patch
Patch0020:        0020-misc-fix-warnings.patch
Patch0021:        0021-fix-GB_TGCLI_GLOBALS-macro.patch
Patch0022:        0022-rpc-switch-to-MT-safe-block-RPC-routines.patch
Patch0023:        0023-rpcl-downstream-Makefile-changes.patch
Patch0024:        0024-socket-switch-to-MT-safe-get-host-addr-info.patch
Patch0025:        0025-daemon-set-configshell-file-loglevel-to-info.patch
Patch0026:        0026-create-clean-metafile-along-with-storage-when-EntryC.patch
Patch0027:        0027-cli-show-prealloc-option-in-the-hint-msg.patch
Patch0028:        0028-delete-rollback-check-for-matching-gbid-before-delet.patch
Patch0029:        0029-cli-defend-on-minimum-block-size.patch
Patch0030:        0030-cli-Be-more-strict-about-what-size-units-we-expect.patch
Patch0031:        0031-cli-make-unit-prefixes-case-insensitive.patch

BuildRequires:    glusterfs-api-devel >= 3.6.0
BuildRequires:    json-c-devel
BuildRequires:    help2man >= 1.36
%if ( 0%{?_with_systemd:1} )
BuildRequires:    systemd-units
%endif

Requires:         tcmu-runner >= 1.2.0-15
Requires:         targetcli >= 2.1.fb46-1

%description
gluster-block is a CLI utility, which aims at making gluster backed block
storage creation and maintenance as simple as possible.

%prep
%autosetup -p1

%build
%configure
make

%install
make DESTDIR=${RPM_BUILD_ROOT} install

%clean
rm -rf ${RPM_BUILD_ROOT}

%files
%license COPYING-GPLV2 COPYING-LGPLV3
%doc README.md INSTALL
%{_sbindir}/gluster-block
%{_sbindir}/gluster-blockd
%{_mandir}/man8/gluster-block*.8*
%if ( 0%{?_with_systemd:1} )
%{_unitdir}/gluster-blockd.service
%{_unitdir}/gluster-block-target.service
%config(noreplace) %{_sysconfdir}/sysconfig/gluster-blockd
%endif

%changelog
* Tue Feb 20 2018 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-14.1
- Consider gbid in delete operations in addition to block name (bz#1545104)
- Delete storage if entry creation fails (bz#1545099)
- Show prealloc option in the hint msg (bz#1545101)
- Defend on minimum block size (bz#1545102)
- Be more strict about size units (bz#1544743)

* Tue Sep 19 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-14
- Fix configshell file loglevel (bz#1493113)

* Tue Sep 19 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-13
- Fix block RPC routines in a way that they behave MT-safe (bz#1492556)

* Fri Sep 15 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-12
- Fix the precedence of systemd units (bz#1491758)

* Fri Sep 08 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-11
- Fix targetcli version check (bz#1489744)

* Fri Sep 01 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-10
- Fix create failure due to missing global attributes (bz#1487527)

* Wed Aug 30 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-9
- Change gluster-block management connection port to 24010 (bz#1483827)
- Improve overall block create/delete/modify response time (bz#1482057)

* Mon Aug 21 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-8
- fix build by adding downstream only configure and makefile changes (bz#1479355)

* Mon Aug 21 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-8
- add gluster-block-target.service to files section of spec file (bz#1479355)

* Mon Aug 21 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-7
- fix build fail, introduced in previous patch attempting to make changes in gitignore (bz#1479355)

* Mon Aug 21 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-7
- Fix partial deletion of block config when few nodes are unavailable (bz#1474256)
- Support configure of logdir via Env variable (bz#1477547)
- Make sure if glusterd is running before bringing the dependent services up (bz#1479355)

* Thu Jul 13 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-6
- Fix, for create request with HA >1, target portals doesn't get created as expected (bz#1470349)

* Mon Jul 10 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-5
- Set backstore attribute cmd time out to zero (bz#1468506)

* Fri Jun 30 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-4
- Fix create block printing (null) when tcmu-runner is not running (bz#1464641)

* Tue Jun 27 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-3
- Remove iscsid from systemd unit and add rpcbind as dependency in spec (bz#1464493)

* Fri Jun 23 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-2
- Gluster-blockd getting started, when rpcbind is not running (bz#1461118)
- Support option to choose between prealloc = full | no (bz#1459839)
- Check for WIFEXITED before WEXITSTATUS (bz#1464402)
- Fix logger (null) prints in place of volumename (bz#1464404)
- Fix cli segfault if log dir doesn't exist (bz#1464405)
- Fix newline char in the cli hint messages (bz#1464408)

* Wed Jun 07 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2.1-1
- Fix server nodes not logging (bz#1458656)
- Fix daemon OOM kill (bz#1456231)
- Better error message when dependent services not running (bz#1454672)
- Info doesn't show status of configured nodes, if any node is down while delete (bz#1454335)
- Fix return value when daemon not responding (bz#1452036)
- Fix daemon exit on receiving SIGPIPE (bz#1453179)
- Fix deletion of blocks that are partially created due to invalid hostname (bz#1456122)
- Fix daemon crash when one of the node is unreachable (bz#1454687)
- Fix heap-buffer-overflow in gluster-blockd (bz#1452919)

* Thu May 25 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2-3
- Fix spec file in 0.2-2, i.e. fix patch application with 'autosetup -p1'

* Mon May 22 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2-2
- Add iscsid service (bz#1449234)
- Fix crash while list action (bz#1450983)
- Create block fails after setting the block profile (bz#1452194)

* Fri May 5 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.2-1
- Initiator cannot discover the targets due to blocking firewalld ports (bz#1444762)
- Daemon crashes when an invalid hostname is given (bz#1446584)
- Gluster-block try to create block device even with invalid host IP (bz#1447360)
- Fix authentication failure while discovering targets from initiator (bz#1444770)
- Cli print msg when daemon is not running (bz#1445364)
- Cli doesn't support json responses (bz#1446572)
- One command for logging-in to all gateways of a target (bz#1446581)

* Sun Mar 26 2017 Prasanna Kumar Kalever <prasanna.kalever@redhat.com> - 0.1.1-1
- Initial import from upstream gluster-block master, package gluster-block (bz#1425465)
